local addonName, addon = ...
local E, L, V, P, G, _ = unpack(ElvUI); --Import: Engine, Locales, PrivateDB, ProfileDB, GlobalDB
local PPBA = E:GetModule(addonName)

-- Defaults
P.general.altpower = {
	['enable'] = true,
	['width'] = 128,
	['height'] = 50,
	['smooth'] = "ALWAYS",
	['color'] = "CUSTOM",
	['customcolor'] = { r = 1, g = 1, b = 1},
	['customalpha'] = 1,
	['backdropcolor'] = "Default",
}

function PPBA:InsertOptions()
	E.Options.args.general.args.altpower = {
		order = 69,
		type = 'group',
		name = L['Alternative Power'],
		get = function(info) return E.db.general.altpower[ info[#info] ] end,
		set = function(info, value) E.db.general.altpower[ info[#info] ] = value end,
		args = {
			enable = {
				order = 0,
				type = "toggle",
				name = L["Enable"],
				set = function(info, value) E.db.general.altpower[ info[#info] ] = value; PPBA:EnableDisable() end,
			},		
			width = {
				order = 1,
				type = "range",
				name = L["Width"],
				min = 50, max = 500, step = 1,
				set = function(info, value) E.db.general.altpower[ info[#info] ] = value; PPBA:UpdateDimensions() end,
			},
			height = {
				order = 2,
				type = "range",
				name = L["Height"],
				min = 10, max = 250, step = 1,
				set = function(info, value) E.db.general.altpower[ info[#info] ] = value; PPBA:UpdateDimensions() end,
			},
			smooth = {
				order = 3,
				type = 'select',
				name = L["Smooth Bars"],
				desc = L['Bars will transition smoothly.'],	
				values = {
					DEFAULT = DEFAULT,
					ALWAYS = ALWAYS,
					NEVER = NEVER,
				},
			},
			color = {
				order = 4,
				type = 'select',
				name = L["Bar Color"],
				values = {
					UNITFRAME = L["Health"].." ("..L["UnitFrames"]..")",
					POWER = L["Power"],
					CLASS = L["Class"],
					CUSTOM = L["Custom Color"],
				},
				set = function(info, value) E.db.general.altpower[ info[#info] ] = value; PPBA:UpdateBarColor() end,
			},	
			customcolor = {
				order = 5,
				type = "color",
				name = L["Custom Color"],
				hasAlpha = false,
				get = function(info)
					local t = E.db.general.altpower[ info[#info] ]
					return t.r, t.g, t.b, t.a
				end,
				set = function(info, r, g, b)
					E.db.general[ info[#info] ] = {}
					local t = E.db.general.altpower[ info[#info] ]
					t.r, t.g, t.b = r, g, b
					PPBA:UpdateBarColor()
				end,	
				disabled = function() return E.db.general.altpower.color ~= "CUSTOM" end,
			},
			customalpha = {
				order = 6,
				type = "range",
				name = L["Custom Alpha"],
				min = 0, max = 1, step = 0.01,
				set = function(info, value) E.db.general.altpower[ info[#info] ] = value; PPBA:UpdateBarColor() end,
			},
			backdropcolor = {
				order = 7,
				type = 'select',
				name = L["Backdrop Color"],
				values = {
					Default = L["Backdrop Color"],
					Transparent = L["Backdrop Faded Color"],
				},
				set = function(info, value) E.db.general.altpower[ info[#info] ] = value; PPBA:UpdateBarColor() end,
			},	
		},
	}
end